<?php

namespace Drupal\wordpress_migrate_sql\Plugin\migrate\source;

use Drupal\migrate\Plugin\migrate\source\SqlBase as DrupalSqlBase;

/**
 * Based table for source wordpress plugin.
 */
abstract class SqlBase extends DrupalSqlBase {

  /**
   * Get database table prefix from the migration template.
   */
  protected function getTableName(string $table_name) {
    $prefix = $this->calculatePrefix();
    if (empty($prefix)) {
      return $table_name;
    }

    return sprintf('%s_%s', $prefix, $table_name);
  }

  /**
   * Calculate the database prefix.
   *
   * @return string
   *   Datbasse prefix. Example: wp.
   */
  protected function calculatePrefix() {

    // Add always configured prefix.
    if (!empty($this->configuration['table_prefix'])) {
      return $this->configuration['table_prefix'];
    }

    // Add default prefix only if no prefix is defined.
    if (empty($this->configuration['table_prefix']) && empty($this->getDatabase()->getPrefix())) {
      return 'wp';
    }

    return NULL;
  }

}
